﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Interactivity;

namespace DiagramLibrary.Adorner
{
    public class AdornerBehavior : Behavior<Canvas>
    {
        #region Member Variables

        private static readonly Random _random = new Random();
        private readonly Adorner _adorner = new Adorner { Width = 0, Height = 0 };

        #endregion

        #region ctor

        public AdornerBehavior()
        {
        }

        #endregion

        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.Loaded += OnLoaded;
        }

        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            foreach (FrameworkElement element in AssociatedObject.Children)
            {
                AdornedObject item = new AdornedObject(element, _random.Next(50) - 25);
                element.Tag = item;
                element.MouseLeftButtonDown += OnMouseLeftButtonDown;
            }
            AssociatedObject.Children.Add(_adorner);
        }

        void OnMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            FrameworkElement img = (FrameworkElement)sender;
            AssociatedObject.Children.Remove(img);
            AssociatedObject.Children.Insert(AssociatedObject.Children.Count - 1, img);
            _adorner.SetAdornedObject((IAdornedObject)img.Tag);
            _adorner.StartMoveDrag();

        }

        protected override void OnDetaching()
        {
            base.OnDetaching();
            foreach (FrameworkElement element in AssociatedObject.Children)
            {
                element.MouseLeftButtonDown -= OnMouseLeftButtonDown;
            }
        }
    };
}
