﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.Generic;

namespace DiagramLibrary.Diagram
{
    //[TemplateVisualState(GroupName = "HoverStates", Name = "NoHover")]
    //[TemplateVisualState(GroupName = "HoverStates", Name = "Hover")]
    //[TemplateVisualState(GroupName = "SelectionStates", Name = "Unselected")]
    //[TemplateVisualState(GroupName = "SelectionStates", Name = "Selected")]
    //public class Connection : ContentControl
    //{
    //    private bool _isDragging;

    //    #region Dependency Properties
        
    //    #region Is Selected

    //    public static readonly DependencyProperty IsSelectedProperty = DependencyProperty.Register(
    //        "IsSelected", typeof(bool), typeof(Connection), new PropertyMetadata(OnIsSelectedChanged));
    //    public bool IsSelected
    //    {
    //        get { return (bool)GetValue(IsSelectedProperty); }
    //        set { SetValue(IsSelectedProperty, value); }
    //    }
    //    private static void OnIsSelectedChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
    //    {
    //        var control = d as Connection;
    //        control.UpdateVisualStates();
    //    }

    //    #endregion

    //    #region Is MouseOver

    //    public static readonly DependencyProperty IsMouseOverProperty = DependencyProperty.Register(
    //        "IsMouseOver", typeof(bool), typeof(Connection), new PropertyMetadata(OnMouseOver));
    //    public bool IsMouseOver
    //    {
    //        get { return (bool)GetValue(IsMouseOverProperty); }
    //        set { SetValue(IsMouseOverProperty, value); }
    //    }
    //    private static void OnMouseOver(DependencyObject d, DependencyPropertyChangedEventArgs e)
    //    {
    //        var control = d as Connection;
    //        control.UpdateVisualStates();
    //    }

    //    #endregion

    //    #endregion

    //    #region ctor

    //    public Connection()
    //    {
    //        DefaultStyleKey = typeof(Connection);

    //        InitializeStoryboard();
    //    }

    //    #endregion

    //    private void InitializeStoryboard()
    //    {
    //    }

    //    protected override void OnMouseEnter(MouseEventArgs e)
    //    {
    //        IsMouseOver = true;
    //        UpdateVisualStates();
    //    }
    //    protected override void OnMouseLeave(MouseEventArgs e)
    //    {
    //        IsMouseOver = false;
    //        UpdateVisualStates();
    //    }
    //    protected override void OnMouseMove(MouseEventArgs e)
    //    {
    //        if (_isDragging)
    //        {

    //        }
    //    }
    //    protected override void OnMouseLeftButtonDown(MouseButtonEventArgs e)
    //    {
    //        _isDragging = true;

    //        CaptureMouse();
    //        IsSelected = true;

    //        UpdateVisualStates();
    //    }
    //    protected override void OnMouseLeftButtonUp(MouseButtonEventArgs e)
    //    {
    //        _isDragging = false;
    //        ReleaseMouseCapture();
    //    }

    //    private void UpdateVisualStates()
    //    {
    //        if (IsMouseOver)
    //        {
    //            VisualStateManager.GoToState(this, "Hover", true);
    //        }
    //        else
    //        {
    //            VisualStateManager.GoToState(this, "NoHover", true);
    //        }

    //        if (IsSelected)
    //        {
    //            VisualStateManager.GoToState(this, "Selected", true);
    //        }
    //        else
    //        {
    //            VisualStateManager.GoToState(this, "Unselected", true);
    //        }
    //    }
    //};

    public class Connection : Control, INotifyPropertyChanged
    {
        #region Properties

        private Connector _source;
        public Connector Source 
        {
            get { return _source; }
            set 
            {
                if (_source != value)
                {
                    if (_source != null)
                    {
                        _source.PropertyChanged -= new PropertyChangedEventHandler(OnConnectorPositionChanged);
                        //_source.Connections.Remove(this);
                    }

                    _source = value;

                    if (_source != null)
                    {
                        //_source.Connections.Add(this);
                        _source.PropertyChanged += new PropertyChangedEventHandler(OnConnectorPositionChanged);
                    }

                    UpdatePathGeometry();

                    OnPropertyChanged("Source");
                }
            } 
        }
        private Connector _sink;
        public Connector Sink
        {
            get { return _sink; }
            set
            {
                if (_sink != value)
                {
                    if (_sink != null)
                    {
                        _sink.PropertyChanged -= new PropertyChangedEventHandler(OnConnectorPositionChanged);
                        //_sink.Connections.Remove(this);
                    }

                    _sink = value;

                    if (_sink != null)
                    {
                        //_sink.Connections.Add(this);
                        _sink.PropertyChanged += new PropertyChangedEventHandler(OnConnectorPositionChanged);
                    }
                    UpdatePathGeometry();

                    OnPropertyChanged("Sink");
                }
            }
        }

        public Line Path { get; set; }
        private Path _path2 = new Path() { Stroke = new SolidColorBrush(Colors.Black), StrokeThickness = 3 };
        public Path Path2
        {
            get { return _path2; }
        }

        // connection path geometry
        private PathGeometry _pathGeometry;
        public PathGeometry PathGeometry
        {
            get { return _pathGeometry; }
            set
            {
                if (_pathGeometry != value)
                {
                    _pathGeometry = value;
                    //UpdateAnchorPosition();
                    Path2.Data = value;
                    OnPropertyChanged("PathGeometry");
                }
            }
        }



        private PathFigureHelper _pathFigureHelper = new PathFigureHelper();
        public PathFigureHelper PathFigureHelper 
        {
            get { return _pathFigureHelper; } 
        }



        // between source connector position and the beginning 
        // of the path geometry we leave some space for visual reasons; 
        // so the anchor position source really marks the beginning 
        // of the path geometry on the source side
        private Point _anchorPositionSource;
        public Point AnchorPositionSource
        {
            get { return _anchorPositionSource; }
            set
            {
                if (_anchorPositionSource != value)
                {
                    _anchorPositionSource = value;
                    OnPropertyChanged("AnchorPositionSource");
                }
            }
        }

        // slope of the path at the anchor position
        // needed for the rotation angle of the arrow
        private double _anchorAngleSource = 0;
        public double AnchorAngleSource
        {
            get { return _anchorAngleSource; }
            set
            {
                if (_anchorAngleSource != value)
                {
                    _anchorAngleSource = value;
                    OnPropertyChanged("AnchorAngleSource");
                }
            }
        }

        // analogue to source side
        private Point _anchorPositionSink;
        public Point AnchorPositionSink
        {
            get { return _anchorPositionSink; }
            set
            {
                if (_anchorPositionSink != value)
                {
                    _anchorPositionSink = value;
                    OnPropertyChanged("AnchorPositionSink");
                }
            }
        }
        // analogue to source side
        private double _anchorAngleSink = 0;
        public double AnchorAngleSink
        {
            get { return _anchorAngleSink; }
            set
            {
                if (_anchorAngleSink != value)
                {
                    _anchorAngleSink = value;
                    OnPropertyChanged("AnchorAngleSink");
                }
            }
        }

        // specifies a point at half path length
        private Point _labelPosition;
        public Point LabelPosition
        {
            get { return _labelPosition; }
            set
            {
                if (_labelPosition != value)
                {
                    _labelPosition = value;
                    OnPropertyChanged("LabelPosition");
                }
            }
        }

        #endregion



        #region ctor
        public Connection()
        {
            Path = new Line();
        }
        #endregion

        void OnConnectorPositionChanged(object sender, PropertyChangedEventArgs e)
        {
            // whenever the 'Position' property of the source or sink Connector 
            // changes we must update the connection path geometry
            if (e.PropertyName.Equals("Position"))
            {
                UpdatePathGeometry();
            }
        }

        public void UpdatePathGeometry()
        {
            if (Source != null && Sink != null)
            {
                PathGeometry geometry = new PathGeometry();
                List<Point> linePoints = PathFinder.GetConnectionLine(Source.GetInfo(), Sink.GetInfo(), true);
                if (linePoints.Count > 0)
                {
                    PathFigure figure = new PathFigure();
                    figure.StartPoint = linePoints[0];
                    linePoints.Remove(linePoints[0]);

                    PolyLineSegment segments = new PolyLineSegment();
                    foreach (Point pt in linePoints)
                    {
                        segments.Points.Add(pt);
                    }

                    //figure.Segments.Add(new PolyLineSegment(linePoints, true));
                    figure.Segments.Add(segments);
                    geometry.Figures.Add(figure);

                    this.PathGeometry = geometry;
                }
            }
        }

        private void UpdateAnchorPosition()
        {
            Point pathStartPoint, pathTangentAtStartPoint;
            Point pathEndPoint, pathTangentAtEndPoint;
            Point pathMidPoint, pathTangentAtMidPoint;

            // the PathGeometry.GetPointAtFractionLength method gets the point and a tangent vector 
            // on PathGeometry at the specified fraction of its length
            this.PathFigureHelper.GetPointAtFractionLength(0, out pathStartPoint, out pathTangentAtStartPoint);
            this.PathFigureHelper.GetPointAtFractionLength(1, out pathEndPoint, out pathTangentAtEndPoint);
            this.PathFigureHelper.GetPointAtFractionLength(0.5, out pathMidPoint, out pathTangentAtMidPoint);
            //cnt.PathGeometry.GetPointAtFractionLength(0, out pathStartPoint, out pathTangentAtStartPoint);
            //cnt.PathGeometry.GetPointAtFractionLength(1, out pathEndPoint, out pathTangentAtEndPoint);
            //cnt.PathGeometry.GetPointAtFractionLength(0.5, out pathMidPoint, out pathTangentAtMidPoint);

            // get angle from tangent vector
            this.AnchorAngleSource = Math.Atan2(-pathTangentAtStartPoint.Y, -pathTangentAtStartPoint.X) * (180 / Math.PI);
            this.AnchorAngleSink = Math.Atan2(pathTangentAtEndPoint.Y, pathTangentAtEndPoint.X) * (180 / Math.PI);

            // add some margin on source and sink side for visual reasons only
            pathStartPoint.Offset(-pathTangentAtStartPoint.X * 5, -pathTangentAtStartPoint.Y * 5);
            pathEndPoint.Offset(pathTangentAtEndPoint.X * 5, pathTangentAtEndPoint.Y * 5);

            this.AnchorPositionSource = pathStartPoint;
            this.AnchorPositionSink = pathEndPoint;
            this.LabelPosition = pathMidPoint;
        }


        #region INotifyPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
        
    };
}
